'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _noKafka = require('no-kafka');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

Function.prototype.$asyncbind = function anonymous(self, catcher) {
  var resolver = this;

  if (catcher === true) {
    if (!Function.prototype.$asyncbind.EagerThenable) Function.prototype.$asyncbind.EagerThenable = function factory(tick) {
      var _tasks = [];

      if (!tick) {
        try {
          tick = process.nextTick;
        } catch (ex) {
          tick = function (p) {
            setTimeout(p, 0);
          };
        }
      }

      function _untask() {
        for (var i = 0; i < _tasks.length; i += 2) {
          var t = _tasks[i + 1],
              r = _tasks[i];

          for (var j = 0; j < t.length; j++) t[j].call(null, r);
        }

        _tasks = [];
      }

      function isThenable(obj) {
        return obj && obj instanceof Object && typeof obj.then === 'function';
      }

      function EagerThenable(resolver) {
        function done(inline) {
          var w;
          if (_sync || phase < 0 || (w = _thens[phase]).length === 0) return;

          _tasks.push(result, w);

          _thens = [[], []];
          if (_tasks.length === 2) inline ? _untask() : tick(_untask);
        }

        function resolveThen(x) {
          if (phase >= 0) return;
          if (isThenable(x)) return x.then(resolveThen, rejectThen);
          phase = 0;
          result = x;
          done(true);
        }

        function rejectThen(x) {
          if (phase >= 0) return;
          if (isThenable(x)) return x.then(resolveThen, rejectThen);
          phase = 1;
          result = x;
          done(true);
        }

        function settler(resolver, rejecter) {
          _thens[0].push(resolver);

          _thens[1].push(rejecter);

          done();
        }

        function toString() {
          return 'EagerThenable{' + {
            '-1': 'pending',
            0: 'resolved',
            1: 'rejected'
          }[phase] + '}=' + result.toString();
        }

        function guard() {
          try {
            resolver.call(null, resolveThen, rejectThen);
          } catch (ex) {
            rejectThen(ex);
          }
        }

        this.then = settler;
        this.toString = toString;
        var _thens = [[], []],
            _sync = true,
            phase = -1,
            result;
        guard();
        _sync = false;
        done();
      }

      EagerThenable.resolve = function (v) {
        return isThenable(v) ? v : {
          then: function (resolve, reject) {
            return resolve(v);
          }
        };
      };

      return EagerThenable;
    }();
    return new Function.prototype.$asyncbind.EagerThenable(boundThen);
  }

  if (catcher) {
    if (Function.prototype.$asyncbind.wrapAsyncStack) catcher = Function.prototype.$asyncbind.wrapAsyncStack(catcher);
    return then;
  }

  function then(result, error) {
    try {
      return result && result instanceof Object && typeof result.then === 'function' ? result.then(then, catcher) : resolver.call(self, result, error || catcher);
    } catch (ex) {
      return (error || catcher)(ex);
    }
  }

  function boundThen(result, error) {
    return resolver.call(self, result, error);
  }

  boundThen.then = boundThen;
  return boundThen;
};

/**
 * The KafkaProducer writes data to a Kafka topic using a formatter,
 * allowing the KafkaFormattedConsumer to extract it later.
 */
class KafkaProducer {

  /**
   * Create a new KafkaProducer
   */
  constructor(formatter, options) {
    this.formatter = formatter;
    this.options = options;
  }

  /**
   * Initialize this instance.
   */
  init() {
    return new _bluebird2.default(function ($return, $error) {
      // If we're already running, succeed silently.
      if (this.running) {
        return $return();
      }

      this.producer = new _noKafka.Producer(this.options.driver);
      return this.producer.init().then(function ($await_1) {
        this.running = true;
        return $return();
      }.$asyncbind(this, $error), $error);
    }.$asyncbind(this));
  }

  /**
   * Write a message to the producer.
   */
  write(messageType, messageBody) {
    return new _bluebird2.default(function ($return, $error) {
      var encoded, result;
      return this.formatter.encodeMessage(messageType, messageBody).then(function ($await_2) {
        encoded = $await_2;
        return this.producer.send({
          topic: this.options.topic,
          partition: 0,
          message: {
            value: encoded
          }
        }).then(function ($await_3) {
          result = $await_3;


          return $return(result);
        }.$asyncbind(this, $error), $error);
      }.$asyncbind(this, $error), $error);
    }.$asyncbind(this));
  }

  /**
   * End this instance.
   */
  end() {
    return new _bluebird2.default(function ($return, $error) {
      // If not running, succeed silently.
      if (!this.running) {
        return $return();
      }

      this.running = false;
      /* istanbul ignore else */
      return this.producer.end().then(function ($await_4) {
        return $return();
      }.$asyncbind(this, $error), $error);
    }.$asyncbind(this));
  }
}
exports.default = KafkaProducer;
//# sourceMappingURL=Producer.js.map
