'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _Sync = require('./Sync');

var _Sync2 = _interopRequireDefault(_Sync);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

Function.prototype.$asyncbind = function anonymous(self, catcher) {
  var resolver = this;

  if (catcher === true) {
    if (!Function.prototype.$asyncbind.EagerThenable) Function.prototype.$asyncbind.EagerThenable = function factory(tick) {
      var _tasks = [];

      if (!tick) {
        try {
          tick = process.nextTick;
        } catch (ex) {
          tick = function (p) {
            setTimeout(p, 0);
          };
        }
      }

      function _untask() {
        for (var i = 0; i < _tasks.length; i += 2) {
          var t = _tasks[i + 1],
              r = _tasks[i];

          for (var j = 0; j < t.length; j++) t[j].call(null, r);
        }

        _tasks = [];
      }

      function isThenable(obj) {
        return obj && obj instanceof Object && typeof obj.then === 'function';
      }

      function EagerThenable(resolver) {
        function done(inline) {
          var w;
          if (_sync || phase < 0 || (w = _thens[phase]).length === 0) return;

          _tasks.push(result, w);

          _thens = [[], []];
          if (_tasks.length === 2) inline ? _untask() : tick(_untask);
        }

        function resolveThen(x) {
          if (phase >= 0) return;
          if (isThenable(x)) return x.then(resolveThen, rejectThen);
          phase = 0;
          result = x;
          done(true);
        }

        function rejectThen(x) {
          if (phase >= 0) return;
          if (isThenable(x)) return x.then(resolveThen, rejectThen);
          phase = 1;
          result = x;
          done(true);
        }

        function settler(resolver, rejecter) {
          _thens[0].push(resolver);

          _thens[1].push(rejecter);

          done();
        }

        function toString() {
          return 'EagerThenable{' + {
            '-1': 'pending',
            0: 'resolved',
            1: 'rejected'
          }[phase] + '}=' + result.toString();
        }

        function guard() {
          try {
            resolver.call(null, resolveThen, rejectThen);
          } catch (ex) {
            rejectThen(ex);
          }
        }

        this.then = settler;
        this.toString = toString;
        var _thens = [[], []],
            _sync = true,
            phase = -1,
            result;
        guard();
        _sync = false;
        done();
      }

      EagerThenable.resolve = function (v) {
        return isThenable(v) ? v : {
          then: function (resolve, reject) {
            return resolve(v);
          }
        };
      };

      return EagerThenable;
    }();
    return new Function.prototype.$asyncbind.EagerThenable(boundThen);
  }

  if (catcher) {
    if (Function.prototype.$asyncbind.wrapAsyncStack) catcher = Function.prototype.$asyncbind.wrapAsyncStack(catcher);
    return then;
  }

  function then(result, error) {
    try {
      return result && result instanceof Object && typeof result.then === 'function' ? result.then(then, catcher) : resolver.call(self, result, error || catcher);
    } catch (ex) {
      return (error || catcher)(ex);
    }
  }

  function boundThen(result, error) {
    return resolver.call(self, result, error);
  }

  boundThen.then = boundThen;
  return boundThen;
};

/**
 * The ThrottledQueue is a mechanism that allows up to N items to be queued,
 * with a promise-based enqueue operation. However, when the Nth item is queued
 * the resolution of the promise is held - until at least one item is dequeued.
 */
class ThrottledQueue {
  /**
   * Initialize a new instance of the ThrottledQueue
   */
  constructor(limit) {
    this.queue = [];
    this.pending = [];
    this.limit = limit;
  }

  /**
   * Queue an item.
   */
  enqueue(value) {
    // Queue the item, if we've got space.
    if (this.queue.length < this.limit) {
      this.queue.push(value);
      return _Sync2.default.resolve();
    }

    return new _bluebird2.default(resolve => {
      this.pending.push({
        resolve,
        value
      });
    });
  }

  /**
   * Pull the next item from the queue.
   */
  dequeue() {
    // Fetch our return value
    let result;
    if (this.queue.length > 0) {
      result = this.queue.shift();
    }

    // Release the next item, if pending
    while (this.queue.length < this.limit && this.pending.length > 0) {
      const nextTask = this.pending.shift();

      // Place into the queue
      this.queue.push(nextTask.value);

      // Resolve on the next tick
      try {
        nextTask.resolve();
      } catch (err) {
        // TODO - Log this - But this is no different to an error
        // on an uncaught next tick.
      }
    }

    return result;
  }
}
exports.default = ThrottledQueue;
//# sourceMappingURL=ThrottledQueue.js.map
